//Bible
/*
TODO LIST:
 - export as csv file for further processing
 - 
 */
PFont fontBig;
PFont fontMiddle;
PFont fontSmall;
String keyword = "";
String lastKeyword = "";
String result = "";
String chapterTxt = "";
String savePicturePath = null;
String saveCsvPath = null;

int lastMouseX = 0;
int lastMouseY = 0;

ChapterReaderUtility crUtil = null;

void setup() {
  frameRate(30);
  size(1000, 700, P2D);
  crUtil = new ChapterReaderUtility();
  crUtil.initFromCompressedBible();
  delay(500);
  fontBig = createFont("Verdana", 48);
  fontMiddle = createFont("Verdana", 24);
  fontSmall = createFont("Verdana", 12);

  keyword = "water";
  startResearch();
  frame.toFront();
}

void draw() {
  background(40, 30, 100, 255);

  crUtil.drawAllChapters();

  textFont(fontMiddle);

  if (keyword.indexOf(",") > -1) {
    String keywords [] = split(keyword, ",");

    if (keywords.length > 1) {
      fill(255, 0, 0, 255);
      text(keywords[0], 20, 660);

      fill(0, 255, 0, 255);
      text(keywords[1], 40, 675);
    }

    if (keywords.length > 2) {
      fill(93, 172, 255, 255);
      text(keywords[2], 60, 690);
    }
  } 
  else {
    fill(255, 255, 255, 255);
    text(keyword, 20, 660);
  }

  fill(255, 255, 255, 255);
  text(result, 20, 570);
  textFont(fontSmall);
  text("Genesis", 10, 30);
  text(chapterTxt, lastMouseX, lastMouseY);
  text("Revelation", 610, 650);

  if (chapterTxt.equals("")) {
    frame.setTitle("Processing Bible Visualization ... " + keyword);
  } 
  else {
    frame.setTitle("Processing Bible Visualization ... " + keyword + " ==> " + chapterTxt);
  }
}

void keyTyped() {

  result = "";

  println(key);

  //RETURN
  if (key == 'P') {
    savePictureToPath(null);
  }
  else if (key == 'C') {
    saveCsvToPath(null);
  }
  else if (int(key) == 10) {
    startResearch();
  } 
  else if (int(key) == 8) { //BACK
    if (keyword.length() > 0) {
      keyword = keyword.substring(0, keyword.length() - 1);
    }
  } 
  else {
    keyword = keyword + key;
    keyword = keyword.replaceAll(",,", ",");
  }
}

void startResearch() {
  try {
    chapterTxt = "";
    keyword = trim(keyword.toLowerCase());
    crUtil.getChaptersByKeyword(keyword);
    lastKeyword = keyword;
  } 
  catch(Exception e) {
    e.printStackTrace();
  }
}

void mouseClicked() {

  chapterTxt = "";

  Chapter chapter = crUtil.getChapterByCoordinates(mouseX, mouseY);

  if (chapter != null) {
    lastMouseX = mouseX;
    lastMouseY = mouseY;
    chapter.drawInfo();
    chapterTxt = chapter.book + " " + chapter.chapterNumber;
    println(chapterTxt);
  } 
  else {
    lastMouseX = 0;
    lastMouseY = 0;
    println("not found");
  }
}

void savePictureToPath(File folder) {
  if (savePicturePath == null) {
    if (folder != null) {
      savePicturePath = folder.getAbsolutePath();
      println(savePicturePath);
    } 
    else {
      selectFolder("Select a folder where to save the ScreenShot", "savePictureToPath");
      return;
    }
  }

  saveFrame(savePicturePath + "/processing-bible-visualisation-" + keyword + "-######.png");
}

void saveCsvToPath(File folder) {
  if (saveCsvPath == null) {
    if (folder != null) {
      saveCsvPath = folder.getAbsolutePath();
      println(saveCsvPath);
    } 
    else {
      selectFolder("Select a folder where to save the CSV Data", "saveCsvToPath");
      return;
    }
  }

  crUtil.saveCsvData(saveCsvPath + "/processing-bible-visualisation-data.csv");
}

