class Chapter {
  Words words = new Words();
  
  PVector location;
  PVector velocity;
  PVector destiny;
  
  int iWidth;
  int iHeight;
  
  int overexpose = 0;
  boolean marked = false;
  
  String book;
  int chapterNumber;
  color chapterColor = color(0,0,0);
  color keywordPresenceColor;
  
  Chapter(String bookName, int chapterN) {
    book = bookName;
    chapterNumber = chapterN;
  }
  
  void draw() {
    stroke(0);
    if (location == null) return;
    
    fill(chapterColor); 
    rect(location.x, location.y, iWidth, iHeight);
    
    if (marked) {
      fill(255,0,0);
      rect(location.x + (iWidth/3), location.y + (iHeight/3), iWidth/2, iHeight/2);
    }
    
    if (overexpose > 0) {
      noStroke();
      fill(chapterColor,overexpose/4);
      ellipse(location.x, location.y, iWidth * overexpose, iHeight * overexpose);
    }
  }
  
  void drawInfo() {
    fill(255,255,255,255); 
    text(book + " " + chapterNumber, location.x, location.y);
  }
}
